include ht48e30.inc

CAOUT	equ	PB.0 
VOUT	equ	PB.1

; set this to the desired resolution
;ADCFSCALE	equ	0			; use 0 for 256 counts (8-bit ADC)
ADCFSCALE	equ	50			; use 50 for 5V Vcc, 0.1 V resolution
;ADCFSCALE	equ	33			; use 33 for 3.3V Vcc, 0.1 V resolution

		public ADCdata,ADC_convert

adcvars	.section 'data'
ADCdata	db ?

adcc	.section 'code'

ADC_convert:
		mov a,ADCFSCALE			; Full scale counts
		clr ADCdata				; Start at 0
		set VOUT				; Charge capacitor
prechg:	snz CAOUT				; Comparator ?
		jmp prechg				; Still LO, loop
		clr VOUT				; Discharge capacitor (keep cycle timing constant)
		jmp loop
DACpulse:
		snz CAOUT				; Comparator ?
		jmp charge				; LO: charge again
		clr VOUT				; HI: discharge capacitor (keep cycle timing constant)
		jmp loop
charge:	set VOUT				; Charge capacitor (keep cycle timing constant)
		inc ADCdata				; increment ADCData
loop:	sdz ACC					; Count, over?
		jmp DACpulse			; No, loop
		clr VOUT		 		; Yes, discharge capacitor
		ret
